/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;

import java.awt.Color;


/**
 * tmarkplugin.config.Property for a Color
 * @author Tomas Schackert
 *
 */
public class ColorProperty extends ConditionalProperty{
	private String key;
	private Color value=null;
	private Color defaultvalue;
	
	public ColorProperty(PropertySource props,ColorProperty src){
		super(props);
		setColor(src);
	}
	public ColorProperty(PropertySource props,String key,Color defaultvalue){
		super(props);
		this.key=key;
		this.defaultvalue=defaultvalue;
	}
	public ColorProperty(PropertySource props,String key,Color defaultvalue,String condkey,boolean defaultcond){
		super(props,condkey,defaultcond);
		this.key=key;
		this.defaultvalue=defaultvalue;
		
	}
	private void load(){
		value=getColorProperty(key,defaultvalue);
	}
	public Color getColor(){
		if (value==null) load();
		return value;
	}
	
	public void setColor(boolean cond,Color c){
		setCondition(cond,false);
		this.setColorProperty(key,this.value=c);
		fireChanged();
	}
	public void setColor(Color c){
		this.setColorProperty(key,this.value=c);
		fireChanged();
	}
	
	
	public void setColor(ColorProperty src){
		super.setCondition(src,false);
		if (src.value==null)src.load();
		this.key=src.key;
		this.defaultvalue=src.defaultvalue;
		this.setColorProperty(key,this.value=src.value);
		fireChanged();
	}
}
