/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;


/**
 * TODO: catch src not found in mapper
 * @author Tomas
 *
 */
public class MappedIntProperty extends MappedProperty {
	IntProperty src;
	HashMap srcToMapped;
	HashMap mappedToSrc;
	/**
	 * @param props
	 */
	public MappedIntProperty(PropertySource props,IntProperty src,HashMap srcToMapped) {
		super(props);
		this.srcToMapped=srcToMapped;
		this.src=src;
		src.addListener(new Property.Listener(){
			public void changedProperty(Property p) {
				MappedIntProperty.this.fireChanged();
			}
		});
		Iterator it=srcToMapped.keySet().iterator();
		mappedToSrc=new HashMap();
		while (it.hasNext()){
			Integer i=(Integer)it.next();
			String v=(String)srcToMapped.get(i);
			mappedToSrc.put(v,i);
		}
	}

	/**
	 * @see tmarkplugin.properties.Property#reset()
	 */
	public void reset() {
		src.reset();
		
	}
	public String get(){
		int i=src.getInt();
		Integer i2=new Integer(i);
		String result=(String)srcToMapped.get(i2);
		return result;
	}
	public void set(String v){
		Integer i=(Integer)mappedToSrc.get(v);
		src.setInt(i.intValue());
	}
	/**
	 * @see tmarkplugin.properties.MappedProperty#getMappedValues()
	 */
	public Vector getMappedValues() {
		return new Vector(srcToMapped.values());
	}

}
