/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;




/**
 * tmarkplugin.config.Property 
 * @author Tomas Schackert
 *
 */
public class VoltileObjectArrayProperty extends Property{
	String key;
	String value[]=null;
	Object unmapped[]=null;
	String defaultvalue[]=null;
	HashMap srcToMapped=null,mappedToSrc=null;
	public VoltileObjectArrayProperty(PropertySource props,VoltileObjectArrayProperty src){
		super(props);
		set(src);
		
	}
	public VoltileObjectArrayProperty(PropertySource props,String key,String defaultvalue[],HashMap srcToMapped){
		super(props);
		this.key=key;
		setMapper(srcToMapped);
		this.defaultvalue=defaultvalue;
	}
	public VoltileObjectArrayProperty(String value[],String defaultvalue[],HashMap srcToMapped){
		super(null);
		this.key=null;
		this.value=value;
		setMapper(srcToMapped);
		this.defaultvalue=defaultvalue;
	}
	private void load(){
		
	}
	public String[] get(){
		return value;
	}
	public void set(String v[]){
		if (Arrays.equals(v,this.value))return;
		
		if (srcToMapped!=null){
			unmapped=new String[v.length];
			for (int i=0;i<v.length;i++){
				unmapped[i]=(String)mappedToSrc.get(v[i]);
			}
			this.value=v;
			//this.setObjectArrayProperty(key,unmapped);
		}else{
			unmapped=null;
			//this.setObjectArrayProperty(key,this.value=v);
		}
		fireChanged();
	}
	public Object[] getUnmapped(){
		return unmapped;
	}
	public void set(VoltileObjectArrayProperty src){
		this.key=src.key;
		this.value=src.value;
		this.unmapped=src.unmapped;
		this.defaultvalue=src.defaultvalue;
		if (src.srcToMapped!=null){
			this.srcToMapped=new HashMap();
			this.srcToMapped.putAll(src.srcToMapped);
			this.mappedToSrc=new HashMap();
			this.mappedToSrc.putAll(src.mappedToSrc);
			//this.setObjectArrayProperty(key,unmapped);
		}else{
			//this.setObjectArrayProperty(key,value);
		}
		fireChanged();
	}
	/**
	 * @see tmarkplugin.data.Property#reset()
	 */
	public void reset() {
		set(defaultvalue);
	}
	private void setMapper(HashMap srcToMapped){
		this.srcToMapped=srcToMapped;
		if (srcToMapped!=null){
			mappedToSrc=new HashMap();
			Iterator it=srcToMapped.keySet().iterator();
			while (it.hasNext()){
				Object k=it.next();
				Object v=srcToMapped.get(k);
				mappedToSrc.put(v,k);
			}
		}else{
			mappedToSrc=null;
		}
	}
	/**
	 * @param strings
	 */
	public void setUnmapped(Object[] src) {
		String v[]=new String[src.length];
		for (int i=0;i<v.length;i++){
			v[i]=(String)srcToMapped.get(src[i]);
		}
		
		if (Arrays.equals(v,this.value))return;
		unmapped=src;
		this.setStringArrayProperty(key,this.value=v);
		
		fireChanged();
	}
}
